--- pbx/pbx_spool.c.orig	2010-04-21 11:21:22.000000000 -0400
+++ pbx/pbx_spool.c	2010-04-21 11:19:55.000000000 -0400
@@ -313,7 +313,7 @@
 	else
 		bname++;	
 	snprintf(newfn, sizeof(newfn), "%s/%s", qdonedir, bname);
-	/* a existing call file the archive dir is overwritten */
+	/* If there is already a call file with the name in the archive dir, it will be overwritten. */
 	unlink(newfn);
 	if (rename(o->fn, newfn) != 0) {
 		unlink(o->fn);
@@ -387,18 +387,18 @@
 
 	/* Attempt to open the file */
 	if (!(f = fopen(fn, "r+"))) {
-		remove_from_queue(o, "Failed");
-		free_outgoing(o);
 		ast_log(LOG_WARNING, "Unable to open %s: %s, deleting\n", fn, strerror(errno));
+		unlink(fn);
+		free_outgoing(o);
 		return -1;
 	}
 
 	/* Read in and verify the contents */
 	if (apply_outgoing(o, fn, f)) {
-		remove_from_queue(o, "Failed");
-		free_outgoing(o);
 		ast_log(LOG_WARNING, "Invalid file contents in %s, deleting\n", fn);
 		fclose(f);
+		remove_from_queue(o, "Failed");
+		free_outgoing(o);
 		return -1;
 	}
 	
